---
name: Bug report
about: Create a report to help us improve
title: ''
labels: bug
assignees: ''

---

#### **Describe the bug**
A clear and concise description of the bug, including your use case for exiv2.

#### **To Reproduce**
Steps to reproduce the behavior:
1. Provide the file with which you observed the issue (commonly named PoC). Explain the status of the file (e.g., direct from camera, edited with darktable), whether you own the copyright and if you allow the file to be added to exiv2 under the [project's license](https://github.com/Exiv2/exiv2/blob/main/COPYING)
2. List the exact commands/functions to reproduce the issue and include any related output
3. Mention the branch and commit in which you observed the issue (e.g., `main, commit 9f721b40`, `0.27-maintenance, latest`)

#### **Expected behavior**
A short description of what you expected to happen.

#### **Desktop (please complete the following information):**
- OS and version: (e.g., Linux (Fedora 36), macOS 12.5, Windows 11)
- Exiv2 version and source: (e.g., 0.27.5 from exiv2.org)
- Compiler and version: (e.g., Gcc 12.2, Clang 14.0.0, MSVC 2022)
- Compilation mode and/or compiler flags: (e.g., debug, `-O3`)

#### **Additional context**
Add any other information about the problem here.
